#ifndef __PROMISE_DUMP__
#define __PROMISE_DUMP__

#include <stdio.h>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdlib.h>


template<typename T>
void dump(T* a, long size)
{
  double * tmp = (double *)malloc(size * sizeof(double));
  for(long i=0; i < size; i++)
    tmp[i] = a[i];
  std::ofstream pfile;
  pfile.open("result.bin", std::ios::binary|std::ofstream::app);
  pfile.write((char*) tmp, sizeof(double)*size);
  pfile.close();
  free(tmp);
}


#ifndef __CADNA__
extern char* strp(double a)
{
  return "";
}

extern void cadna_init(int i)
{
  return ;
}

extern void cadna_end()
{
  return ;
}
#endif

#ifdef __CADNA__
#ifndef __PROMISE_CADNA__
#define __PROMISE_CADNA__
extern void dump_cad(double_st* a, long size)
{
  std::cout << "dump stochastic double" << std::endl;
  double * tmp = (double *)malloc(size * 3 *sizeof(double));
  for(long i=0; i < size; i++){
    tmp[3*i] = (double)a[i].getx();
    tmp[(3*i)+1] = (double)a[i].gety();
    tmp[(3*i)+2] = (double)a[i].getz();
  }
  std::ofstream pfile;
  pfile.open("result.bin", std::ios::binary|std::ofstream::app);
  pfile.write((char*) tmp, sizeof(double)*size*3);
  pfile.close();
  free(tmp);
}

extern void dump_cad(float_st* a, long size)
{
  std::cout << "dump stochastic double" << std::endl;
  double * tmp = (double *)malloc(size * 3 *sizeof(double));
  for(long i=0; i < size; i++){
    tmp[3*i] = (double)a[i].getx();
    tmp[(3*i)+1] = (double)a[i].gety();
    tmp[(3*i)+2] = (double)a[i].getz();
  }
  std::ofstream pfile;
  pfile.open("result.bin", std::ios::binary|std::ofstream::app);
  pfile.write((char*) tmp, sizeof(double)*size*3);
  pfile.close();
  free(tmp);
}

extern void dump(double_st* a, long size)
{
  std::cout << "dump stochastic double" << std::endl;
  double * tmp = (double *)malloc(size * 3 *sizeof(double));
  for(long i=0; i < size; i++){
    tmp[3*i] = (double)a[i].getx();
    tmp[(3*i)+1] = (double)a[i].gety();
    tmp[(3*i)+2] = (double)a[i].getz();
  }
  std::ofstream pfile;
  pfile.open("result.bin", std::ios::binary|std::ofstream::app);
  pfile.write((char*) tmp, sizeof(double)*size*3);
  pfile.close();
  free(tmp);
}

extern void dump(float_st* a, long size)
{
  std::cout << "dump stochastic double" << std::endl;
  double * tmp = (double *)malloc(size * 3 *sizeof(double));
  for(long i=0; i < size; i++){
    tmp[3*i] = (double)a[i].getx();
    tmp[(3*i)+1] = (double)a[i].gety();
    tmp[(3*i)+2] = (double)a[i].getz();
  }
  std::ofstream pfile;
  pfile.open("result.bin", std::ios::binary|std::ofstream::app);
  pfile.write((char*) tmp, sizeof(double)*size*3);
  pfile.close();
  free(tmp);
}
#endif
#endif


template<typename T>
extern void dump(T a)
{
  dump(&a,1);
}

#endif // #ifndef __PROMISE_DUMP__
