#include<cadna.h>
#include "dump.h"
# include <cstdlib>
# include <iostream>
# include <fstream>
# include <iomanip>
# include <cmath>
# include <ctime>

typedef double_st atype;
typedef double_st btype;
typedef double_st ctype;
typedef double ieee;

ieee *matgen ( int m, int n, int *seed );

int main ( int argc, char *argv[] )
{
  btype *b;
  ctype *c;
  ieee *tmp;
  int n1;
  int n2;
  int n3;
  int seed;
  n1 = atoi ( argv[1] );
  n2 = atoi ( argv[2] );
  n3 = atoi ( argv[3] );
  
  seed = 42;
  tmp = matgen ( n1, n2, &seed );
  b = new btype[n1*n2];
  c = new ctype[n1*n2];
  for(int i=0; i< n1*n2;i++)
    b[i]=tmp[i];
  delete tmp;
  tmp = matgen ( n2, n3, &seed );
  for(int i=0; i< n2*n3;i++)
    c[i]=tmp[i];
  delete tmp;
  cadna_init(-1);

  atype *a;
  int i;
  int j;
  int k;

  a = new atype[n1*n3];

  for ( j = 0; j < n3; j++ )
  {
    for ( i = 0; i < n1; i++ )
    {
      a[i+j*n1] = 0.0;
    }
  }

  for ( i = 0; i < n1; i++ )
  {
    for ( j = 0; j < n3; j++ )
    {
      for ( k = 0; k < n2; k++ )
      {
        a[i+j*n1] = a[i+j*n1] + b[i+k*n1] * c[k+j*n2];
      }
    }
  }

  dump(a, n1*n3);
  delete [] a;


  cadna_end();

  return 0;

  cadna_end();
}
//****************************************************************************80

//****************************************************************************80

ieee *matgen ( int m, int n, int *seed )
{
  ieee *a;
  int i;
  int j;

  a = new ieee[m*n];
  for ( j = 0;j < n; j++ )
  {
    for ( i = 0; i < m; i++ )
    {
      *seed = ( ( 3125 * *seed ) % 65536 );
      a[i+j*m] = ( *seed - 20768.0 ) / 16384.0;
    }
  }

  return a;
}
