//Copyright 2016 Romain PICOT
//Modified in 2019 by Fabienne JEZEQUEL
//
//This file is part of PROMISE.
//
//    PROMISE is free software: you can redistribute it and/or modify it
//    under the terms of the GNU Lesser General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    PROMISE is distributed in the hope that it will be useful, but WITHOUT
//    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General
//    Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with PROMISE. If not, see
//    <http://www.gnu.org/licenses/>.
//
#include <cadna.h>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <stdlib.h>

int compare(  char* prefname,
	      char* pvalname,
	      int Digits)
{  
  std::ifstream pref;
  std::ifstream pval;
  char buf1[100];
  char buf2[100];
  char buf3[100];
  int cpt = 0;
  //  int cpt_diff = 0; //FJ
  pref.open(prefname,std::ifstream::binary);
  pval.open(pvalname,std::ifstream::binary);
  int Digits_ = Digits;

  //  while(pref != NULL && pval != NULL) //FJ
  //  while(pref  && pval) //FJ
  while(pref.good()  && pval.good()) //FJ
    {
      pref.read((char*)buf1,sizeof(double));
      pref.read((char*)buf2,sizeof(double));
      pref.read((char*)buf3,sizeof(double));
      double_st ref = double_st(*((double*)(buf1)),
				*((double*)(buf2)),
				*((double*)(buf3)));
      pval.read((char*)buf1,sizeof(double));
      pval.read((char*)buf2,sizeof(double));
      pval.read((char*)buf3,sizeof(double));
      if(pref.eof() ||  pval.eof() ) break; //otherwise performs an extra (useless) iteration
      double_st val = double_st(*((double*)(buf1)),
				*((double*)(buf2)),
				*((double*)(buf3)));
      if((fabs(ref-val)) >= (fabs(ref)*pow(10,-Digits_))){
	if(ref != 0.){
	  pref.close();
	  pval.close();
	  std::cout << "cpt: " << cpt << std::endl;
	  std::cout << "(fabs(ref-val)) " << (fabs(ref-val)) << std::endl;
	  std::cout << "(fabs(ref)*pow(10,-Digits_)) " << (fabs(ref)*pow(10,-Digits_)) << std::endl;
	  return 1; 
	}
      }
      if(val.nb_significant_digit()<Digits_){
	std::cout << "cpt: " << cpt << std::endl;
	std::cout << "val.nb_significant_digit " << val.nb_significant_digit() << std::endl;
	pref.close();
	pval.close();
	return 1;
      }
      cpt++;
    }

  //  if (pref!=NULL || pval != NULL){ //FJ
  if (pref || pval ){
    pref.close();
    pval.close();
    std::cout << "error: not the same size" << std::endl;
    return 1;
  }
  pref.close();
  pval.close();

  return 0;
}

int digit(char* prefname,
	  int Digits)
{
  std::ifstream pref;
  pref.open(prefname,std::ios::binary);
  int Digits_ = Digits;
  int cpt = 0;
  char buf1[100];
  char buf2[100];
  char buf3[100];
  
  //  while(pref != NULL) //FJ
  //    while(pref)
    while(pref.good()) //FJ
    {
      pref.read(buf1,sizeof(double));
      pref.read(buf2,sizeof(double));
      pref.read(buf3,sizeof(double));
      if(pref.eof() ) break; //otherwise performs an extra (useless) iteration
      cpt++;
      double_st ref = double_st(*((double*)buf1),
				*((double*)buf2),
				*((double*)buf3));
      if(ref.nb_significant_digit()<Digits_){
	std::cout << "cpt: " << cpt << std::endl;
	std::cout << "nb_chiffres: " << ref.nb_significant_digit() << std::endl;
	std::cout << "ref: " << ref << std::endl;
	std::cout <<std::setprecision(15) << ref.getx() << " " << ref.gety() << " " <<  ref.getz() <<std::endl;;
	pref.close();
	return 1;
      }
    }
  pref.close();
  return 0;
}


int main(int argc, char* argv[])
{
  if (argc == 4)
        return compare(argv[1],argv[2],atoi(argv[3]));

  if(argc == 3)
    return digit(argv[1],atoi(argv[2]));
  return 42;
}
